<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfAllowanceCharge ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfAllowanceCharge
 * @subpackage Arrays
 */
class ArrayOfAllowanceCharge extends AbstractStructArrayBase
{
    /**
     * The AllowanceCharge
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\AllowanceCharge[]
     */
    public $AllowanceCharge;
    /**
     * Constructor method for ArrayOfAllowanceCharge
     * @uses ArrayOfAllowanceCharge::setAllowanceCharge()
     * @param \StructType\AllowanceCharge[] $allowanceCharge
     */
    public function __construct(array $allowanceCharge = array())
    {
        $this
            ->setAllowanceCharge($allowanceCharge);
    }
    /**
     * Get AllowanceCharge value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\AllowanceCharge[]|null
     */
    public function getAllowanceCharge()
    {
        return isset($this->AllowanceCharge) ? $this->AllowanceCharge : null;
    }
    /**
     * This method is responsible for validating the values passed to the setAllowanceCharge method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAllowanceCharge method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAllowanceChargeForArrayConstraintsFromSetAllowanceCharge(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfAllowanceChargeAllowanceChargeItem) {
            // validation for constraint: itemType
            if (!$arrayOfAllowanceChargeAllowanceChargeItem instanceof \StructType\AllowanceCharge) {
                $invalidValues[] = is_object($arrayOfAllowanceChargeAllowanceChargeItem) ? get_class($arrayOfAllowanceChargeAllowanceChargeItem) : sprintf('%s(%s)', gettype($arrayOfAllowanceChargeAllowanceChargeItem), var_export($arrayOfAllowanceChargeAllowanceChargeItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The AllowanceCharge property can only contain items of type \StructType\AllowanceCharge, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set AllowanceCharge value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\AllowanceCharge[] $allowanceCharge
     * @return \ArrayType\ArrayOfAllowanceCharge
     */
    public function setAllowanceCharge(array $allowanceCharge = array())
    {
        // validation for constraint: array
        if ('' !== ($allowanceChargeArrayErrorMessage = self::validateAllowanceChargeForArrayConstraintsFromSetAllowanceCharge($allowanceCharge))) {
            throw new \InvalidArgumentException($allowanceChargeArrayErrorMessage, __LINE__);
        }
        if (is_null($allowanceCharge) || (is_array($allowanceCharge) && empty($allowanceCharge))) {
            unset($this->AllowanceCharge);
        } else {
            $this->AllowanceCharge = $allowanceCharge;
        }
        return $this;
    }
    /**
     * Add item to AllowanceCharge value
     * @throws \InvalidArgumentException
     * @param \StructType\AllowanceCharge $item
     * @return \ArrayType\ArrayOfAllowanceCharge
     */
    public function addToAllowanceCharge(\StructType\AllowanceCharge $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AllowanceCharge) {
            throw new \InvalidArgumentException(sprintf('The AllowanceCharge property can only contain items of type \StructType\AllowanceCharge, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->AllowanceCharge[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\AllowanceCharge|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\AllowanceCharge|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\AllowanceCharge|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\AllowanceCharge|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\AllowanceCharge|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string AllowanceCharge
     */
    public function getAttributeName()
    {
        return 'AllowanceCharge';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfAllowanceCharge
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
