<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfBillingReferenceLine ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfBillingReferenceLine
 * @subpackage Arrays
 */
class ArrayOfBillingReferenceLine extends AbstractStructArrayBase
{
    /**
     * The BillingReferenceLine
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\BillingReferenceLine[]
     */
    public $BillingReferenceLine;
    /**
     * Constructor method for ArrayOfBillingReferenceLine
     * @uses ArrayOfBillingReferenceLine::setBillingReferenceLine()
     * @param \StructType\BillingReferenceLine[] $billingReferenceLine
     */
    public function __construct(array $billingReferenceLine = array())
    {
        $this
            ->setBillingReferenceLine($billingReferenceLine);
    }
    /**
     * Get BillingReferenceLine value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\BillingReferenceLine[]|null
     */
    public function getBillingReferenceLine()
    {
        return isset($this->BillingReferenceLine) ? $this->BillingReferenceLine : null;
    }
    /**
     * This method is responsible for validating the values passed to the setBillingReferenceLine method
     * This method is willingly generated in order to preserve the one-line inline validation within the setBillingReferenceLine method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateBillingReferenceLineForArrayConstraintsFromSetBillingReferenceLine(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfBillingReferenceLineBillingReferenceLineItem) {
            // validation for constraint: itemType
            if (!$arrayOfBillingReferenceLineBillingReferenceLineItem instanceof \StructType\BillingReferenceLine) {
                $invalidValues[] = is_object($arrayOfBillingReferenceLineBillingReferenceLineItem) ? get_class($arrayOfBillingReferenceLineBillingReferenceLineItem) : sprintf('%s(%s)', gettype($arrayOfBillingReferenceLineBillingReferenceLineItem), var_export($arrayOfBillingReferenceLineBillingReferenceLineItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The BillingReferenceLine property can only contain items of type \StructType\BillingReferenceLine, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set BillingReferenceLine value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\BillingReferenceLine[] $billingReferenceLine
     * @return \ArrayType\ArrayOfBillingReferenceLine
     */
    public function setBillingReferenceLine(array $billingReferenceLine = array())
    {
        // validation for constraint: array
        if ('' !== ($billingReferenceLineArrayErrorMessage = self::validateBillingReferenceLineForArrayConstraintsFromSetBillingReferenceLine($billingReferenceLine))) {
            throw new \InvalidArgumentException($billingReferenceLineArrayErrorMessage, __LINE__);
        }
        if (is_null($billingReferenceLine) || (is_array($billingReferenceLine) && empty($billingReferenceLine))) {
            unset($this->BillingReferenceLine);
        } else {
            $this->BillingReferenceLine = $billingReferenceLine;
        }
        return $this;
    }
    /**
     * Add item to BillingReferenceLine value
     * @throws \InvalidArgumentException
     * @param \StructType\BillingReferenceLine $item
     * @return \ArrayType\ArrayOfBillingReferenceLine
     */
    public function addToBillingReferenceLine(\StructType\BillingReferenceLine $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\BillingReferenceLine) {
            throw new \InvalidArgumentException(sprintf('The BillingReferenceLine property can only contain items of type \StructType\BillingReferenceLine, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->BillingReferenceLine[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\BillingReferenceLine|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\BillingReferenceLine|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\BillingReferenceLine|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\BillingReferenceLine|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\BillingReferenceLine|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string BillingReferenceLine
     */
    public function getAttributeName()
    {
        return 'BillingReferenceLine';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfBillingReferenceLine
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
