<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfCustomPostBoxEnvelopeDTO ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfCustomPostBoxEnvelopeDTO
 * @subpackage Arrays
 */
class ArrayOfCustomPostBoxEnvelopeDTO extends AbstractStructArrayBase
{
    /**
     * The CustomPostBoxEnvelopeDTO
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\CustomPostBoxEnvelopeDTO[]
     */
    public $CustomPostBoxEnvelopeDTO;
    /**
     * Constructor method for ArrayOfCustomPostBoxEnvelopeDTO
     * @uses ArrayOfCustomPostBoxEnvelopeDTO::setCustomPostBoxEnvelopeDTO()
     * @param \StructType\CustomPostBoxEnvelopeDTO[] $customPostBoxEnvelopeDTO
     */
    public function __construct(array $customPostBoxEnvelopeDTO = array())
    {
        $this
            ->setCustomPostBoxEnvelopeDTO($customPostBoxEnvelopeDTO);
    }
    /**
     * Get CustomPostBoxEnvelopeDTO value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\CustomPostBoxEnvelopeDTO[]|null
     */
    public function getCustomPostBoxEnvelopeDTO()
    {
        return isset($this->CustomPostBoxEnvelopeDTO) ? $this->CustomPostBoxEnvelopeDTO : null;
    }
    /**
     * This method is responsible for validating the values passed to the setCustomPostBoxEnvelopeDTO method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCustomPostBoxEnvelopeDTO method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCustomPostBoxEnvelopeDTOForArrayConstraintsFromSetCustomPostBoxEnvelopeDTO(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfCustomPostBoxEnvelopeDTOCustomPostBoxEnvelopeDTOItem) {
            // validation for constraint: itemType
            if (!$arrayOfCustomPostBoxEnvelopeDTOCustomPostBoxEnvelopeDTOItem instanceof \StructType\CustomPostBoxEnvelopeDTO) {
                $invalidValues[] = is_object($arrayOfCustomPostBoxEnvelopeDTOCustomPostBoxEnvelopeDTOItem) ? get_class($arrayOfCustomPostBoxEnvelopeDTOCustomPostBoxEnvelopeDTOItem) : sprintf('%s(%s)', gettype($arrayOfCustomPostBoxEnvelopeDTOCustomPostBoxEnvelopeDTOItem), var_export($arrayOfCustomPostBoxEnvelopeDTOCustomPostBoxEnvelopeDTOItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The CustomPostBoxEnvelopeDTO property can only contain items of type \StructType\CustomPostBoxEnvelopeDTO, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set CustomPostBoxEnvelopeDTO value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\CustomPostBoxEnvelopeDTO[] $customPostBoxEnvelopeDTO
     * @return \ArrayType\ArrayOfCustomPostBoxEnvelopeDTO
     */
    public function setCustomPostBoxEnvelopeDTO(array $customPostBoxEnvelopeDTO = array())
    {
        // validation for constraint: array
        if ('' !== ($customPostBoxEnvelopeDTOArrayErrorMessage = self::validateCustomPostBoxEnvelopeDTOForArrayConstraintsFromSetCustomPostBoxEnvelopeDTO($customPostBoxEnvelopeDTO))) {
            throw new \InvalidArgumentException($customPostBoxEnvelopeDTOArrayErrorMessage, __LINE__);
        }
        if (is_null($customPostBoxEnvelopeDTO) || (is_array($customPostBoxEnvelopeDTO) && empty($customPostBoxEnvelopeDTO))) {
            unset($this->CustomPostBoxEnvelopeDTO);
        } else {
            $this->CustomPostBoxEnvelopeDTO = $customPostBoxEnvelopeDTO;
        }
        return $this;
    }
    /**
     * Add item to CustomPostBoxEnvelopeDTO value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomPostBoxEnvelopeDTO $item
     * @return \ArrayType\ArrayOfCustomPostBoxEnvelopeDTO
     */
    public function addToCustomPostBoxEnvelopeDTO(\StructType\CustomPostBoxEnvelopeDTO $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CustomPostBoxEnvelopeDTO) {
            throw new \InvalidArgumentException(sprintf('The CustomPostBoxEnvelopeDTO property can only contain items of type \StructType\CustomPostBoxEnvelopeDTO, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->CustomPostBoxEnvelopeDTO[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\CustomPostBoxEnvelopeDTO|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\CustomPostBoxEnvelopeDTO|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\CustomPostBoxEnvelopeDTO|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\CustomPostBoxEnvelopeDTO|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\CustomPostBoxEnvelopeDTO|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string CustomPostBoxEnvelopeDTO
     */
    public function getAttributeName()
    {
        return 'CustomPostBoxEnvelopeDTO';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfCustomPostBoxEnvelopeDTO
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
