<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfHazardousGoodsTransit ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfHazardousGoodsTransit
 * @subpackage Arrays
 */
class ArrayOfHazardousGoodsTransit extends AbstractStructArrayBase
{
    /**
     * The HazardousGoodsTransit
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\HazardousGoodsTransit[]
     */
    public $HazardousGoodsTransit;
    /**
     * Constructor method for ArrayOfHazardousGoodsTransit
     * @uses ArrayOfHazardousGoodsTransit::setHazardousGoodsTransit()
     * @param \StructType\HazardousGoodsTransit[] $hazardousGoodsTransit
     */
    public function __construct(array $hazardousGoodsTransit = array())
    {
        $this
            ->setHazardousGoodsTransit($hazardousGoodsTransit);
    }
    /**
     * Get HazardousGoodsTransit value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\HazardousGoodsTransit[]|null
     */
    public function getHazardousGoodsTransit()
    {
        return isset($this->HazardousGoodsTransit) ? $this->HazardousGoodsTransit : null;
    }
    /**
     * This method is responsible for validating the values passed to the setHazardousGoodsTransit method
     * This method is willingly generated in order to preserve the one-line inline validation within the setHazardousGoodsTransit method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateHazardousGoodsTransitForArrayConstraintsFromSetHazardousGoodsTransit(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfHazardousGoodsTransitHazardousGoodsTransitItem) {
            // validation for constraint: itemType
            if (!$arrayOfHazardousGoodsTransitHazardousGoodsTransitItem instanceof \StructType\HazardousGoodsTransit) {
                $invalidValues[] = is_object($arrayOfHazardousGoodsTransitHazardousGoodsTransitItem) ? get_class($arrayOfHazardousGoodsTransitHazardousGoodsTransitItem) : sprintf('%s(%s)', gettype($arrayOfHazardousGoodsTransitHazardousGoodsTransitItem), var_export($arrayOfHazardousGoodsTransitHazardousGoodsTransitItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The HazardousGoodsTransit property can only contain items of type \StructType\HazardousGoodsTransit, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set HazardousGoodsTransit value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\HazardousGoodsTransit[] $hazardousGoodsTransit
     * @return \ArrayType\ArrayOfHazardousGoodsTransit
     */
    public function setHazardousGoodsTransit(array $hazardousGoodsTransit = array())
    {
        // validation for constraint: array
        if ('' !== ($hazardousGoodsTransitArrayErrorMessage = self::validateHazardousGoodsTransitForArrayConstraintsFromSetHazardousGoodsTransit($hazardousGoodsTransit))) {
            throw new \InvalidArgumentException($hazardousGoodsTransitArrayErrorMessage, __LINE__);
        }
        if (is_null($hazardousGoodsTransit) || (is_array($hazardousGoodsTransit) && empty($hazardousGoodsTransit))) {
            unset($this->HazardousGoodsTransit);
        } else {
            $this->HazardousGoodsTransit = $hazardousGoodsTransit;
        }
        return $this;
    }
    /**
     * Add item to HazardousGoodsTransit value
     * @throws \InvalidArgumentException
     * @param \StructType\HazardousGoodsTransit $item
     * @return \ArrayType\ArrayOfHazardousGoodsTransit
     */
    public function addToHazardousGoodsTransit(\StructType\HazardousGoodsTransit $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\HazardousGoodsTransit) {
            throw new \InvalidArgumentException(sprintf('The HazardousGoodsTransit property can only contain items of type \StructType\HazardousGoodsTransit, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->HazardousGoodsTransit[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\HazardousGoodsTransit|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\HazardousGoodsTransit|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\HazardousGoodsTransit|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\HazardousGoodsTransit|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\HazardousGoodsTransit|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string HazardousGoodsTransit
     */
    public function getAttributeName()
    {
        return 'HazardousGoodsTransit';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfHazardousGoodsTransit
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
