<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfInvoiceSubLine ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfInvoiceSubLine
 * @subpackage Arrays
 */
class ArrayOfInvoiceSubLine extends AbstractStructArrayBase
{
    /**
     * The InvoiceSubLine
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\InvoiceSubLine[]
     */
    public $InvoiceSubLine;
    /**
     * Constructor method for ArrayOfInvoiceSubLine
     * @uses ArrayOfInvoiceSubLine::setInvoiceSubLine()
     * @param \StructType\InvoiceSubLine[] $invoiceSubLine
     */
    public function __construct(array $invoiceSubLine = array())
    {
        $this
            ->setInvoiceSubLine($invoiceSubLine);
    }
    /**
     * Get InvoiceSubLine value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\InvoiceSubLine[]|null
     */
    public function getInvoiceSubLine()
    {
        return isset($this->InvoiceSubLine) ? $this->InvoiceSubLine : null;
    }
    /**
     * This method is responsible for validating the values passed to the setInvoiceSubLine method
     * This method is willingly generated in order to preserve the one-line inline validation within the setInvoiceSubLine method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateInvoiceSubLineForArrayConstraintsFromSetInvoiceSubLine(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfInvoiceSubLineInvoiceSubLineItem) {
            // validation for constraint: itemType
            if (!$arrayOfInvoiceSubLineInvoiceSubLineItem instanceof \StructType\InvoiceSubLine) {
                $invalidValues[] = is_object($arrayOfInvoiceSubLineInvoiceSubLineItem) ? get_class($arrayOfInvoiceSubLineInvoiceSubLineItem) : sprintf('%s(%s)', gettype($arrayOfInvoiceSubLineInvoiceSubLineItem), var_export($arrayOfInvoiceSubLineInvoiceSubLineItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The InvoiceSubLine property can only contain items of type \StructType\InvoiceSubLine, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set InvoiceSubLine value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\InvoiceSubLine[] $invoiceSubLine
     * @return \ArrayType\ArrayOfInvoiceSubLine
     */
    public function setInvoiceSubLine(array $invoiceSubLine = array())
    {
        // validation for constraint: array
        if ('' !== ($invoiceSubLineArrayErrorMessage = self::validateInvoiceSubLineForArrayConstraintsFromSetInvoiceSubLine($invoiceSubLine))) {
            throw new \InvalidArgumentException($invoiceSubLineArrayErrorMessage, __LINE__);
        }
        if (is_null($invoiceSubLine) || (is_array($invoiceSubLine) && empty($invoiceSubLine))) {
            unset($this->InvoiceSubLine);
        } else {
            $this->InvoiceSubLine = $invoiceSubLine;
        }
        return $this;
    }
    /**
     * Add item to InvoiceSubLine value
     * @throws \InvalidArgumentException
     * @param \StructType\InvoiceSubLine $item
     * @return \ArrayType\ArrayOfInvoiceSubLine
     */
    public function addToInvoiceSubLine(\StructType\InvoiceSubLine $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\InvoiceSubLine) {
            throw new \InvalidArgumentException(sprintf('The InvoiceSubLine property can only contain items of type \StructType\InvoiceSubLine, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->InvoiceSubLine[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\InvoiceSubLine|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\InvoiceSubLine|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\InvoiceSubLine|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\InvoiceSubLine|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\InvoiceSubLine|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string InvoiceSubLine
     */
    public function getAttributeName()
    {
        return 'InvoiceSubLine';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfInvoiceSubLine
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
