<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfOrderLineReference ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfOrderLineReference
 * @subpackage Arrays
 */
class ArrayOfOrderLineReference extends AbstractStructArrayBase
{
    /**
     * The OrderLineReference
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\OrderLineReference[]
     */
    public $OrderLineReference;
    /**
     * Constructor method for ArrayOfOrderLineReference
     * @uses ArrayOfOrderLineReference::setOrderLineReference()
     * @param \StructType\OrderLineReference[] $orderLineReference
     */
    public function __construct(array $orderLineReference = array())
    {
        $this
            ->setOrderLineReference($orderLineReference);
    }
    /**
     * Get OrderLineReference value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\OrderLineReference[]|null
     */
    public function getOrderLineReference()
    {
        return isset($this->OrderLineReference) ? $this->OrderLineReference : null;
    }
    /**
     * This method is responsible for validating the values passed to the setOrderLineReference method
     * This method is willingly generated in order to preserve the one-line inline validation within the setOrderLineReference method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateOrderLineReferenceForArrayConstraintsFromSetOrderLineReference(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfOrderLineReferenceOrderLineReferenceItem) {
            // validation for constraint: itemType
            if (!$arrayOfOrderLineReferenceOrderLineReferenceItem instanceof \StructType\OrderLineReference) {
                $invalidValues[] = is_object($arrayOfOrderLineReferenceOrderLineReferenceItem) ? get_class($arrayOfOrderLineReferenceOrderLineReferenceItem) : sprintf('%s(%s)', gettype($arrayOfOrderLineReferenceOrderLineReferenceItem), var_export($arrayOfOrderLineReferenceOrderLineReferenceItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The OrderLineReference property can only contain items of type \StructType\OrderLineReference, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set OrderLineReference value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\OrderLineReference[] $orderLineReference
     * @return \ArrayType\ArrayOfOrderLineReference
     */
    public function setOrderLineReference(array $orderLineReference = array())
    {
        // validation for constraint: array
        if ('' !== ($orderLineReferenceArrayErrorMessage = self::validateOrderLineReferenceForArrayConstraintsFromSetOrderLineReference($orderLineReference))) {
            throw new \InvalidArgumentException($orderLineReferenceArrayErrorMessage, __LINE__);
        }
        if (is_null($orderLineReference) || (is_array($orderLineReference) && empty($orderLineReference))) {
            unset($this->OrderLineReference);
        } else {
            $this->OrderLineReference = $orderLineReference;
        }
        return $this;
    }
    /**
     * Add item to OrderLineReference value
     * @throws \InvalidArgumentException
     * @param \StructType\OrderLineReference $item
     * @return \ArrayType\ArrayOfOrderLineReference
     */
    public function addToOrderLineReference(\StructType\OrderLineReference $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\OrderLineReference) {
            throw new \InvalidArgumentException(sprintf('The OrderLineReference property can only contain items of type \StructType\OrderLineReference, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->OrderLineReference[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\OrderLineReference|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\OrderLineReference|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\OrderLineReference|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\OrderLineReference|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\OrderLineReference|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string OrderLineReference
     */
    public function getAttributeName()
    {
        return 'OrderLineReference';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfOrderLineReference
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
