<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfOutgoingInvoice ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfOutgoingInvoice
 * @subpackage Arrays
 */
class ArrayOfOutgoingInvoice extends AbstractStructArrayBase
{
    /**
     * The OutgoingInvoice
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\OutgoingInvoice[]
     */
    public $OutgoingInvoice;
    /**
     * Constructor method for ArrayOfOutgoingInvoice
     * @uses ArrayOfOutgoingInvoice::setOutgoingInvoice()
     * @param \StructType\OutgoingInvoice[] $outgoingInvoice
     */
    public function __construct(array $outgoingInvoice = array())
    {
        $this
            ->setOutgoingInvoice($outgoingInvoice);
    }
    /**
     * Get OutgoingInvoice value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\OutgoingInvoice[]|null
     */
    public function getOutgoingInvoice()
    {
        return isset($this->OutgoingInvoice) ? $this->OutgoingInvoice : null;
    }
    /**
     * This method is responsible for validating the values passed to the setOutgoingInvoice method
     * This method is willingly generated in order to preserve the one-line inline validation within the setOutgoingInvoice method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateOutgoingInvoiceForArrayConstraintsFromSetOutgoingInvoice(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfOutgoingInvoiceOutgoingInvoiceItem) {
            // validation for constraint: itemType
            if (!$arrayOfOutgoingInvoiceOutgoingInvoiceItem instanceof \StructType\OutgoingInvoice) {
                $invalidValues[] = is_object($arrayOfOutgoingInvoiceOutgoingInvoiceItem) ? get_class($arrayOfOutgoingInvoiceOutgoingInvoiceItem) : sprintf('%s(%s)', gettype($arrayOfOutgoingInvoiceOutgoingInvoiceItem), var_export($arrayOfOutgoingInvoiceOutgoingInvoiceItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The OutgoingInvoice property can only contain items of type \StructType\OutgoingInvoice, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set OutgoingInvoice value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\OutgoingInvoice[] $outgoingInvoice
     * @return \ArrayType\ArrayOfOutgoingInvoice
     */
    public function setOutgoingInvoice(array $outgoingInvoice = array())
    {
        // validation for constraint: array
        if ('' !== ($outgoingInvoiceArrayErrorMessage = self::validateOutgoingInvoiceForArrayConstraintsFromSetOutgoingInvoice($outgoingInvoice))) {
            throw new \InvalidArgumentException($outgoingInvoiceArrayErrorMessage, __LINE__);
        }
        if (is_null($outgoingInvoice) || (is_array($outgoingInvoice) && empty($outgoingInvoice))) {
            unset($this->OutgoingInvoice);
        } else {
            $this->OutgoingInvoice = $outgoingInvoice;
        }
        return $this;
    }
    /**
     * Add item to OutgoingInvoice value
     * @throws \InvalidArgumentException
     * @param \StructType\OutgoingInvoice $item
     * @return \ArrayType\ArrayOfOutgoingInvoice
     */
    public function addToOutgoingInvoice(\StructType\OutgoingInvoice $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\OutgoingInvoice) {
            throw new \InvalidArgumentException(sprintf('The OutgoingInvoice property can only contain items of type \StructType\OutgoingInvoice, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->OutgoingInvoice[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\OutgoingInvoice|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\OutgoingInvoice|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\OutgoingInvoice|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\OutgoingInvoice|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\OutgoingInvoice|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string OutgoingInvoice
     */
    public function getAttributeName()
    {
        return 'OutgoingInvoice';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfOutgoingInvoice
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
