<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfOutgoingInvoiceRaw ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfOutgoingInvoiceRaw
 * @subpackage Arrays
 */
class ArrayOfOutgoingInvoiceRaw extends AbstractStructArrayBase
{
    /**
     * The OutgoingInvoiceRaw
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\OutgoingInvoiceRaw[]
     */
    public $OutgoingInvoiceRaw;
    /**
     * Constructor method for ArrayOfOutgoingInvoiceRaw
     * @uses ArrayOfOutgoingInvoiceRaw::setOutgoingInvoiceRaw()
     * @param \StructType\OutgoingInvoiceRaw[] $outgoingInvoiceRaw
     */
    public function __construct(array $outgoingInvoiceRaw = array())
    {
        $this
            ->setOutgoingInvoiceRaw($outgoingInvoiceRaw);
    }
    /**
     * Get OutgoingInvoiceRaw value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\OutgoingInvoiceRaw[]|null
     */
    public function getOutgoingInvoiceRaw()
    {
        return isset($this->OutgoingInvoiceRaw) ? $this->OutgoingInvoiceRaw : null;
    }
    /**
     * This method is responsible for validating the values passed to the setOutgoingInvoiceRaw method
     * This method is willingly generated in order to preserve the one-line inline validation within the setOutgoingInvoiceRaw method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateOutgoingInvoiceRawForArrayConstraintsFromSetOutgoingInvoiceRaw(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfOutgoingInvoiceRawOutgoingInvoiceRawItem) {
            // validation for constraint: itemType
            if (!$arrayOfOutgoingInvoiceRawOutgoingInvoiceRawItem instanceof \StructType\OutgoingInvoiceRaw) {
                $invalidValues[] = is_object($arrayOfOutgoingInvoiceRawOutgoingInvoiceRawItem) ? get_class($arrayOfOutgoingInvoiceRawOutgoingInvoiceRawItem) : sprintf('%s(%s)', gettype($arrayOfOutgoingInvoiceRawOutgoingInvoiceRawItem), var_export($arrayOfOutgoingInvoiceRawOutgoingInvoiceRawItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The OutgoingInvoiceRaw property can only contain items of type \StructType\OutgoingInvoiceRaw, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set OutgoingInvoiceRaw value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\OutgoingInvoiceRaw[] $outgoingInvoiceRaw
     * @return \ArrayType\ArrayOfOutgoingInvoiceRaw
     */
    public function setOutgoingInvoiceRaw(array $outgoingInvoiceRaw = array())
    {
        // validation for constraint: array
        if ('' !== ($outgoingInvoiceRawArrayErrorMessage = self::validateOutgoingInvoiceRawForArrayConstraintsFromSetOutgoingInvoiceRaw($outgoingInvoiceRaw))) {
            throw new \InvalidArgumentException($outgoingInvoiceRawArrayErrorMessage, __LINE__);
        }
        if (is_null($outgoingInvoiceRaw) || (is_array($outgoingInvoiceRaw) && empty($outgoingInvoiceRaw))) {
            unset($this->OutgoingInvoiceRaw);
        } else {
            $this->OutgoingInvoiceRaw = $outgoingInvoiceRaw;
        }
        return $this;
    }
    /**
     * Add item to OutgoingInvoiceRaw value
     * @throws \InvalidArgumentException
     * @param \StructType\OutgoingInvoiceRaw $item
     * @return \ArrayType\ArrayOfOutgoingInvoiceRaw
     */
    public function addToOutgoingInvoiceRaw(\StructType\OutgoingInvoiceRaw $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\OutgoingInvoiceRaw) {
            throw new \InvalidArgumentException(sprintf('The OutgoingInvoiceRaw property can only contain items of type \StructType\OutgoingInvoiceRaw, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->OutgoingInvoiceRaw[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\OutgoingInvoiceRaw|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\OutgoingInvoiceRaw|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\OutgoingInvoiceRaw|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\OutgoingInvoiceRaw|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\OutgoingInvoiceRaw|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string OutgoingInvoiceRaw
     */
    public function getAttributeName()
    {
        return 'OutgoingInvoiceRaw';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfOutgoingInvoiceRaw
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
