<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPartyIdentification ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfPartyIdentification
 * @subpackage Arrays
 */
class ArrayOfPartyIdentification extends AbstractStructArrayBase
{
    /**
     * The PartyIdentification
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\PartyIdentification[]
     */
    public $PartyIdentification;
    /**
     * Constructor method for ArrayOfPartyIdentification
     * @uses ArrayOfPartyIdentification::setPartyIdentification()
     * @param \StructType\PartyIdentification[] $partyIdentification
     */
    public function __construct(array $partyIdentification = array())
    {
        $this
            ->setPartyIdentification($partyIdentification);
    }
    /**
     * Get PartyIdentification value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\PartyIdentification[]|null
     */
    public function getPartyIdentification()
    {
        return isset($this->PartyIdentification) ? $this->PartyIdentification : null;
    }
    /**
     * This method is responsible for validating the values passed to the setPartyIdentification method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPartyIdentification method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePartyIdentificationForArrayConstraintsFromSetPartyIdentification(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPartyIdentificationPartyIdentificationItem) {
            // validation for constraint: itemType
            if (!$arrayOfPartyIdentificationPartyIdentificationItem instanceof \StructType\PartyIdentification) {
                $invalidValues[] = is_object($arrayOfPartyIdentificationPartyIdentificationItem) ? get_class($arrayOfPartyIdentificationPartyIdentificationItem) : sprintf('%s(%s)', gettype($arrayOfPartyIdentificationPartyIdentificationItem), var_export($arrayOfPartyIdentificationPartyIdentificationItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PartyIdentification property can only contain items of type \StructType\PartyIdentification, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PartyIdentification value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\PartyIdentification[] $partyIdentification
     * @return \ArrayType\ArrayOfPartyIdentification
     */
    public function setPartyIdentification(array $partyIdentification = array())
    {
        // validation for constraint: array
        if ('' !== ($partyIdentificationArrayErrorMessage = self::validatePartyIdentificationForArrayConstraintsFromSetPartyIdentification($partyIdentification))) {
            throw new \InvalidArgumentException($partyIdentificationArrayErrorMessage, __LINE__);
        }
        if (is_null($partyIdentification) || (is_array($partyIdentification) && empty($partyIdentification))) {
            unset($this->PartyIdentification);
        } else {
            $this->PartyIdentification = $partyIdentification;
        }
        return $this;
    }
    /**
     * Add item to PartyIdentification value
     * @throws \InvalidArgumentException
     * @param \StructType\PartyIdentification $item
     * @return \ArrayType\ArrayOfPartyIdentification
     */
    public function addToPartyIdentification(\StructType\PartyIdentification $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PartyIdentification) {
            throw new \InvalidArgumentException(sprintf('The PartyIdentification property can only contain items of type \StructType\PartyIdentification, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PartyIdentification[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\PartyIdentification|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\PartyIdentification|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\PartyIdentification|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\PartyIdentification|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\PartyIdentification|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PartyIdentification
     */
    public function getAttributeName()
    {
        return 'PartyIdentification';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfPartyIdentification
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
