<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfReceiverAlias ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfReceiverAlias
 * @subpackage Arrays
 */
class ArrayOfReceiverAlias extends AbstractStructArrayBase
{
    /**
     * The ReceiverAlias
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ReceiverAlias[]
     */
    public $ReceiverAlias;
    /**
     * Constructor method for ArrayOfReceiverAlias
     * @uses ArrayOfReceiverAlias::setReceiverAlias()
     * @param \StructType\ReceiverAlias[] $receiverAlias
     */
    public function __construct(array $receiverAlias = array())
    {
        $this
            ->setReceiverAlias($receiverAlias);
    }
    /**
     * Get ReceiverAlias value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ReceiverAlias[]|null
     */
    public function getReceiverAlias()
    {
        return isset($this->ReceiverAlias) ? $this->ReceiverAlias : null;
    }
    /**
     * This method is responsible for validating the values passed to the setReceiverAlias method
     * This method is willingly generated in order to preserve the one-line inline validation within the setReceiverAlias method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateReceiverAliasForArrayConstraintsFromSetReceiverAlias(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfReceiverAliasReceiverAliasItem) {
            // validation for constraint: itemType
            if (!$arrayOfReceiverAliasReceiverAliasItem instanceof \StructType\ReceiverAlias) {
                $invalidValues[] = is_object($arrayOfReceiverAliasReceiverAliasItem) ? get_class($arrayOfReceiverAliasReceiverAliasItem) : sprintf('%s(%s)', gettype($arrayOfReceiverAliasReceiverAliasItem), var_export($arrayOfReceiverAliasReceiverAliasItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ReceiverAlias property can only contain items of type \StructType\ReceiverAlias, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ReceiverAlias value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ReceiverAlias[] $receiverAlias
     * @return \ArrayType\ArrayOfReceiverAlias
     */
    public function setReceiverAlias(array $receiverAlias = array())
    {
        // validation for constraint: array
        if ('' !== ($receiverAliasArrayErrorMessage = self::validateReceiverAliasForArrayConstraintsFromSetReceiverAlias($receiverAlias))) {
            throw new \InvalidArgumentException($receiverAliasArrayErrorMessage, __LINE__);
        }
        if (is_null($receiverAlias) || (is_array($receiverAlias) && empty($receiverAlias))) {
            unset($this->ReceiverAlias);
        } else {
            $this->ReceiverAlias = $receiverAlias;
        }
        return $this;
    }
    /**
     * Add item to ReceiverAlias value
     * @throws \InvalidArgumentException
     * @param \StructType\ReceiverAlias $item
     * @return \ArrayType\ArrayOfReceiverAlias
     */
    public function addToReceiverAlias(\StructType\ReceiverAlias $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ReceiverAlias) {
            throw new \InvalidArgumentException(sprintf('The ReceiverAlias property can only contain items of type \StructType\ReceiverAlias, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ReceiverAlias[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ReceiverAlias|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ReceiverAlias|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ReceiverAlias|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ReceiverAlias|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ReceiverAlias|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ReceiverAlias
     */
    public function getAttributeName()
    {
        return 'ReceiverAlias';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfReceiverAlias
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
