<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfReplyInvoiceItem ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfReplyInvoiceItem
 * @subpackage Arrays
 */
class ArrayOfReplyInvoiceItem extends AbstractStructArrayBase
{
    /**
     * The ReplyInvoiceItem
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ReplyInvoiceItem[]
     */
    public $ReplyInvoiceItem;
    /**
     * Constructor method for ArrayOfReplyInvoiceItem
     * @uses ArrayOfReplyInvoiceItem::setReplyInvoiceItem()
     * @param \StructType\ReplyInvoiceItem[] $replyInvoiceItem
     */
    public function __construct(array $replyInvoiceItem = array())
    {
        $this
            ->setReplyInvoiceItem($replyInvoiceItem);
    }
    /**
     * Get ReplyInvoiceItem value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ReplyInvoiceItem[]|null
     */
    public function getReplyInvoiceItem()
    {
        return isset($this->ReplyInvoiceItem) ? $this->ReplyInvoiceItem : null;
    }
    /**
     * This method is responsible for validating the values passed to the setReplyInvoiceItem method
     * This method is willingly generated in order to preserve the one-line inline validation within the setReplyInvoiceItem method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateReplyInvoiceItemForArrayConstraintsFromSetReplyInvoiceItem(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfReplyInvoiceItemReplyInvoiceItemItem) {
            // validation for constraint: itemType
            if (!$arrayOfReplyInvoiceItemReplyInvoiceItemItem instanceof \StructType\ReplyInvoiceItem) {
                $invalidValues[] = is_object($arrayOfReplyInvoiceItemReplyInvoiceItemItem) ? get_class($arrayOfReplyInvoiceItemReplyInvoiceItemItem) : sprintf('%s(%s)', gettype($arrayOfReplyInvoiceItemReplyInvoiceItemItem), var_export($arrayOfReplyInvoiceItemReplyInvoiceItemItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ReplyInvoiceItem property can only contain items of type \StructType\ReplyInvoiceItem, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ReplyInvoiceItem value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ReplyInvoiceItem[] $replyInvoiceItem
     * @return \ArrayType\ArrayOfReplyInvoiceItem
     */
    public function setReplyInvoiceItem(array $replyInvoiceItem = array())
    {
        // validation for constraint: array
        if ('' !== ($replyInvoiceItemArrayErrorMessage = self::validateReplyInvoiceItemForArrayConstraintsFromSetReplyInvoiceItem($replyInvoiceItem))) {
            throw new \InvalidArgumentException($replyInvoiceItemArrayErrorMessage, __LINE__);
        }
        if (is_null($replyInvoiceItem) || (is_array($replyInvoiceItem) && empty($replyInvoiceItem))) {
            unset($this->ReplyInvoiceItem);
        } else {
            $this->ReplyInvoiceItem = $replyInvoiceItem;
        }
        return $this;
    }
    /**
     * Add item to ReplyInvoiceItem value
     * @throws \InvalidArgumentException
     * @param \StructType\ReplyInvoiceItem $item
     * @return \ArrayType\ArrayOfReplyInvoiceItem
     */
    public function addToReplyInvoiceItem(\StructType\ReplyInvoiceItem $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ReplyInvoiceItem) {
            throw new \InvalidArgumentException(sprintf('The ReplyInvoiceItem property can only contain items of type \StructType\ReplyInvoiceItem, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ReplyInvoiceItem[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ReplyInvoiceItem|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ReplyInvoiceItem|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ReplyInvoiceItem|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ReplyInvoiceItem|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ReplyInvoiceItem|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ReplyInvoiceItem
     */
    public function getAttributeName()
    {
        return 'ReplyInvoiceItem';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfReplyInvoiceItem
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
