<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfShipmentStage ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfShipmentStage
 * @subpackage Arrays
 */
class ArrayOfShipmentStage extends AbstractStructArrayBase
{
    /**
     * The ShipmentStage
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ShipmentStage[]
     */
    public $ShipmentStage;
    /**
     * Constructor method for ArrayOfShipmentStage
     * @uses ArrayOfShipmentStage::setShipmentStage()
     * @param \StructType\ShipmentStage[] $shipmentStage
     */
    public function __construct(array $shipmentStage = array())
    {
        $this
            ->setShipmentStage($shipmentStage);
    }
    /**
     * Get ShipmentStage value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ShipmentStage[]|null
     */
    public function getShipmentStage()
    {
        return isset($this->ShipmentStage) ? $this->ShipmentStage : null;
    }
    /**
     * This method is responsible for validating the values passed to the setShipmentStage method
     * This method is willingly generated in order to preserve the one-line inline validation within the setShipmentStage method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateShipmentStageForArrayConstraintsFromSetShipmentStage(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfShipmentStageShipmentStageItem) {
            // validation for constraint: itemType
            if (!$arrayOfShipmentStageShipmentStageItem instanceof \StructType\ShipmentStage) {
                $invalidValues[] = is_object($arrayOfShipmentStageShipmentStageItem) ? get_class($arrayOfShipmentStageShipmentStageItem) : sprintf('%s(%s)', gettype($arrayOfShipmentStageShipmentStageItem), var_export($arrayOfShipmentStageShipmentStageItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ShipmentStage property can only contain items of type \StructType\ShipmentStage, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ShipmentStage value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ShipmentStage[] $shipmentStage
     * @return \ArrayType\ArrayOfShipmentStage
     */
    public function setShipmentStage(array $shipmentStage = array())
    {
        // validation for constraint: array
        if ('' !== ($shipmentStageArrayErrorMessage = self::validateShipmentStageForArrayConstraintsFromSetShipmentStage($shipmentStage))) {
            throw new \InvalidArgumentException($shipmentStageArrayErrorMessage, __LINE__);
        }
        if (is_null($shipmentStage) || (is_array($shipmentStage) && empty($shipmentStage))) {
            unset($this->ShipmentStage);
        } else {
            $this->ShipmentStage = $shipmentStage;
        }
        return $this;
    }
    /**
     * Add item to ShipmentStage value
     * @throws \InvalidArgumentException
     * @param \StructType\ShipmentStage $item
     * @return \ArrayType\ArrayOfShipmentStage
     */
    public function addToShipmentStage(\StructType\ShipmentStage $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ShipmentStage) {
            throw new \InvalidArgumentException(sprintf('The ShipmentStage property can only contain items of type \StructType\ShipmentStage, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ShipmentStage[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ShipmentStage|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ShipmentStage|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ShipmentStage|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ShipmentStage|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ShipmentStage|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ShipmentStage
     */
    public function getAttributeName()
    {
        return 'ShipmentStage';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfShipmentStage
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
