<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTransportHandlingUnit ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfTransportHandlingUnit
 * @subpackage Arrays
 */
class ArrayOfTransportHandlingUnit extends AbstractStructArrayBase
{
    /**
     * The TransportHandlingUnit
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TransportHandlingUnit[]
     */
    public $TransportHandlingUnit;
    /**
     * Constructor method for ArrayOfTransportHandlingUnit
     * @uses ArrayOfTransportHandlingUnit::setTransportHandlingUnit()
     * @param \StructType\TransportHandlingUnit[] $transportHandlingUnit
     */
    public function __construct(array $transportHandlingUnit = array())
    {
        $this
            ->setTransportHandlingUnit($transportHandlingUnit);
    }
    /**
     * Get TransportHandlingUnit value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TransportHandlingUnit[]|null
     */
    public function getTransportHandlingUnit()
    {
        return isset($this->TransportHandlingUnit) ? $this->TransportHandlingUnit : null;
    }
    /**
     * This method is responsible for validating the values passed to the setTransportHandlingUnit method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTransportHandlingUnit method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTransportHandlingUnitForArrayConstraintsFromSetTransportHandlingUnit(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfTransportHandlingUnitTransportHandlingUnitItem) {
            // validation for constraint: itemType
            if (!$arrayOfTransportHandlingUnitTransportHandlingUnitItem instanceof \StructType\TransportHandlingUnit) {
                $invalidValues[] = is_object($arrayOfTransportHandlingUnitTransportHandlingUnitItem) ? get_class($arrayOfTransportHandlingUnitTransportHandlingUnitItem) : sprintf('%s(%s)', gettype($arrayOfTransportHandlingUnitTransportHandlingUnitItem), var_export($arrayOfTransportHandlingUnitTransportHandlingUnitItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The TransportHandlingUnit property can only contain items of type \StructType\TransportHandlingUnit, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set TransportHandlingUnit value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TransportHandlingUnit[] $transportHandlingUnit
     * @return \ArrayType\ArrayOfTransportHandlingUnit
     */
    public function setTransportHandlingUnit(array $transportHandlingUnit = array())
    {
        // validation for constraint: array
        if ('' !== ($transportHandlingUnitArrayErrorMessage = self::validateTransportHandlingUnitForArrayConstraintsFromSetTransportHandlingUnit($transportHandlingUnit))) {
            throw new \InvalidArgumentException($transportHandlingUnitArrayErrorMessage, __LINE__);
        }
        if (is_null($transportHandlingUnit) || (is_array($transportHandlingUnit) && empty($transportHandlingUnit))) {
            unset($this->TransportHandlingUnit);
        } else {
            $this->TransportHandlingUnit = $transportHandlingUnit;
        }
        return $this;
    }
    /**
     * Add item to TransportHandlingUnit value
     * @throws \InvalidArgumentException
     * @param \StructType\TransportHandlingUnit $item
     * @return \ArrayType\ArrayOfTransportHandlingUnit
     */
    public function addToTransportHandlingUnit(\StructType\TransportHandlingUnit $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TransportHandlingUnit) {
            throw new \InvalidArgumentException(sprintf('The TransportHandlingUnit property can only contain items of type \StructType\TransportHandlingUnit, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->TransportHandlingUnit[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\TransportHandlingUnit|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\TransportHandlingUnit|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\TransportHandlingUnit|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\TransportHandlingUnit|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\TransportHandlingUnit|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TransportHandlingUnit
     */
    public function getAttributeName()
    {
        return 'TransportHandlingUnit';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfTransportHandlingUnit
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
