<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTransportMeans ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfTransportMeans
 * @subpackage Arrays
 */
class ArrayOfTransportMeans extends AbstractStructArrayBase
{
    /**
     * The TransportMeans
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TransportMeans[]
     */
    public $TransportMeans;
    /**
     * Constructor method for ArrayOfTransportMeans
     * @uses ArrayOfTransportMeans::setTransportMeans()
     * @param \StructType\TransportMeans[] $transportMeans
     */
    public function __construct(array $transportMeans = array())
    {
        $this
            ->setTransportMeans($transportMeans);
    }
    /**
     * Get TransportMeans value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TransportMeans[]|null
     */
    public function getTransportMeans()
    {
        return isset($this->TransportMeans) ? $this->TransportMeans : null;
    }
    /**
     * This method is responsible for validating the values passed to the setTransportMeans method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTransportMeans method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTransportMeansForArrayConstraintsFromSetTransportMeans(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfTransportMeansTransportMeansItem) {
            // validation for constraint: itemType
            if (!$arrayOfTransportMeansTransportMeansItem instanceof \StructType\TransportMeans) {
                $invalidValues[] = is_object($arrayOfTransportMeansTransportMeansItem) ? get_class($arrayOfTransportMeansTransportMeansItem) : sprintf('%s(%s)', gettype($arrayOfTransportMeansTransportMeansItem), var_export($arrayOfTransportMeansTransportMeansItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The TransportMeans property can only contain items of type \StructType\TransportMeans, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set TransportMeans value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TransportMeans[] $transportMeans
     * @return \ArrayType\ArrayOfTransportMeans
     */
    public function setTransportMeans(array $transportMeans = array())
    {
        // validation for constraint: array
        if ('' !== ($transportMeansArrayErrorMessage = self::validateTransportMeansForArrayConstraintsFromSetTransportMeans($transportMeans))) {
            throw new \InvalidArgumentException($transportMeansArrayErrorMessage, __LINE__);
        }
        if (is_null($transportMeans) || (is_array($transportMeans) && empty($transportMeans))) {
            unset($this->TransportMeans);
        } else {
            $this->TransportMeans = $transportMeans;
        }
        return $this;
    }
    /**
     * Add item to TransportMeans value
     * @throws \InvalidArgumentException
     * @param \StructType\TransportMeans $item
     * @return \ArrayType\ArrayOfTransportMeans
     */
    public function addToTransportMeans(\StructType\TransportMeans $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TransportMeans) {
            throw new \InvalidArgumentException(sprintf('The TransportMeans property can only contain items of type \StructType\TransportMeans, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->TransportMeans[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\TransportMeans|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\TransportMeans|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\TransportMeans|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\TransportMeans|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\TransportMeans|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TransportMeans
     */
    public function getAttributeName()
    {
        return 'TransportMeans';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfTransportMeans
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
