<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for InvoiceInquiryResponse StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:InvoiceInquiryResponse
 * @subpackage Structs
 */
class InvoiceInquiryResponse extends ResponseBase
{
    /**
     * The EmailAddress
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $EmailAddress;
    /**
     * The EmailDescription
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $EmailDescription;
    /**
     * The EmailStatus
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $EmailStatus;
    /**
     * The EmailStatusDescription
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $EmailStatusDescription;
    /**
     * The EnvelopeStatus
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $EnvelopeStatus;
    /**
     * The EnvelopeStatusDescription
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $EnvelopeStatusDescription;
    /**
     * The HashValue
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $HashValue;
    /**
     * The InvoiceNumber
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $InvoiceNumber;
    /**
     * The InvoiceStatus
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $InvoiceStatus;
    /**
     * The InvoiceStatusDescription
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $InvoiceStatusDescription;
    /**
     * The IsCancelled
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $IsCancelled;
    /**
     * The IsCompleted
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $IsCompleted;
    /**
     * The Notes
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Notes;
    /**
     * The SmsDescription
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $SmsDescription;
    /**
     * The SmsStatus
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $SmsStatus;
    /**
     * The SmsStatusDescription
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $SmsStatusDescription;
    /**
     * The UUID
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $UUID;
    /**
     * The InvoiceInquiryResult
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\InvoiceInquiryResponse
     */
    public $InvoiceInquiryResult;
    /**
     * Constructor method for InvoiceInquiryResponse
     * @uses InvoiceInquiryResponse::setEmailAddress()
     * @uses InvoiceInquiryResponse::setEmailDescription()
     * @uses InvoiceInquiryResponse::setEmailStatus()
     * @uses InvoiceInquiryResponse::setEmailStatusDescription()
     * @uses InvoiceInquiryResponse::setEnvelopeStatus()
     * @uses InvoiceInquiryResponse::setEnvelopeStatusDescription()
     * @uses InvoiceInquiryResponse::setHashValue()
     * @uses InvoiceInquiryResponse::setInvoiceNumber()
     * @uses InvoiceInquiryResponse::setInvoiceStatus()
     * @uses InvoiceInquiryResponse::setInvoiceStatusDescription()
     * @uses InvoiceInquiryResponse::setIsCancelled()
     * @uses InvoiceInquiryResponse::setIsCompleted()
     * @uses InvoiceInquiryResponse::setNotes()
     * @uses InvoiceInquiryResponse::setSmsDescription()
     * @uses InvoiceInquiryResponse::setSmsStatus()
     * @uses InvoiceInquiryResponse::setSmsStatusDescription()
     * @uses InvoiceInquiryResponse::setUUID()
     * @uses InvoiceInquiryResponse::setInvoiceInquiryResult()
     * @param string $emailAddress
     * @param string $emailDescription
     * @param int $emailStatus
     * @param string $emailStatusDescription
     * @param int $envelopeStatus
     * @param string $envelopeStatusDescription
     * @param string $hashValue
     * @param string $invoiceNumber
     * @param int $invoiceStatus
     * @param string $invoiceStatusDescription
     * @param bool $isCancelled
     * @param bool $isCompleted
     * @param string $notes
     * @param string $smsDescription
     * @param int $smsStatus
     * @param string $smsStatusDescription
     * @param string $uUID
     * @param \StructType\InvoiceInquiryResponse $invoiceInquiryResult
     */
    public function __construct($emailAddress = null, $emailDescription = null, $emailStatus = null, $emailStatusDescription = null, $envelopeStatus = null, $envelopeStatusDescription = null, $hashValue = null, $invoiceNumber = null, $invoiceStatus = null, $invoiceStatusDescription = null, $isCancelled = null, $isCompleted = null, $notes = null, $smsDescription = null, $smsStatus = null, $smsStatusDescription = null, $uUID = null, \StructType\InvoiceInquiryResponse $invoiceInquiryResult = null)
    {
        $this
            ->setEmailAddress($emailAddress)
            ->setEmailDescription($emailDescription)
            ->setEmailStatus($emailStatus)
            ->setEmailStatusDescription($emailStatusDescription)
            ->setEnvelopeStatus($envelopeStatus)
            ->setEnvelopeStatusDescription($envelopeStatusDescription)
            ->setHashValue($hashValue)
            ->setInvoiceNumber($invoiceNumber)
            ->setInvoiceStatus($invoiceStatus)
            ->setInvoiceStatusDescription($invoiceStatusDescription)
            ->setIsCancelled($isCancelled)
            ->setIsCompleted($isCompleted)
            ->setNotes($notes)
            ->setSmsDescription($smsDescription)
            ->setSmsStatus($smsStatus)
            ->setSmsStatusDescription($smsStatusDescription)
            ->setUUID($uUID)
            ->setInvoiceInquiryResult($invoiceInquiryResult);
    }
    /**
     * Get EmailAddress value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getEmailAddress()
    {
        return isset($this->EmailAddress) ? $this->EmailAddress : null;
    }
    /**
     * Set EmailAddress value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $emailAddress
     * @return \StructType\InvoiceInquiryResponse
     */
    public function setEmailAddress($emailAddress = null)
    {
        // validation for constraint: string
        if (!is_null($emailAddress) && !is_string($emailAddress)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($emailAddress, true), gettype($emailAddress)), __LINE__);
        }
        if (is_null($emailAddress) || (is_array($emailAddress) && empty($emailAddress))) {
            unset($this->EmailAddress);
        } else {
            $this->EmailAddress = $emailAddress;
        }
        return $this;
    }
    /**
     * Get EmailDescription value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getEmailDescription()
    {
        return isset($this->EmailDescription) ? $this->EmailDescription : null;
    }
    /**
     * Set EmailDescription value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $emailDescription
     * @return \StructType\InvoiceInquiryResponse
     */
    public function setEmailDescription($emailDescription = null)
    {
        // validation for constraint: string
        if (!is_null($emailDescription) && !is_string($emailDescription)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($emailDescription, true), gettype($emailDescription)), __LINE__);
        }
        if (is_null($emailDescription) || (is_array($emailDescription) && empty($emailDescription))) {
            unset($this->EmailDescription);
        } else {
            $this->EmailDescription = $emailDescription;
        }
        return $this;
    }
    /**
     * Get EmailStatus value
     * @return int|null
     */
    public function getEmailStatus()
    {
        return $this->EmailStatus;
    }
    /**
     * Set EmailStatus value
     * @param int $emailStatus
     * @return \StructType\InvoiceInquiryResponse
     */
    public function setEmailStatus($emailStatus = null)
    {
        // validation for constraint: int
        if (!is_null($emailStatus) && !(is_int($emailStatus) || ctype_digit($emailStatus))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($emailStatus, true), gettype($emailStatus)), __LINE__);
        }
        $this->EmailStatus = $emailStatus;
        return $this;
    }
    /**
     * Get EmailStatusDescription value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getEmailStatusDescription()
    {
        return isset($this->EmailStatusDescription) ? $this->EmailStatusDescription : null;
    }
    /**
     * Set EmailStatusDescription value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $emailStatusDescription
     * @return \StructType\InvoiceInquiryResponse
     */
    public function setEmailStatusDescription($emailStatusDescription = null)
    {
        // validation for constraint: string
        if (!is_null($emailStatusDescription) && !is_string($emailStatusDescription)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($emailStatusDescription, true), gettype($emailStatusDescription)), __LINE__);
        }
        if (is_null($emailStatusDescription) || (is_array($emailStatusDescription) && empty($emailStatusDescription))) {
            unset($this->EmailStatusDescription);
        } else {
            $this->EmailStatusDescription = $emailStatusDescription;
        }
        return $this;
    }
    /**
     * Get EnvelopeStatus value
     * @return int|null
     */
    public function getEnvelopeStatus()
    {
        return $this->EnvelopeStatus;
    }
    /**
     * Set EnvelopeStatus value
     * @param int $envelopeStatus
     * @return \StructType\InvoiceInquiryResponse
     */
    public function setEnvelopeStatus($envelopeStatus = null)
    {
        // validation for constraint: int
        if (!is_null($envelopeStatus) && !(is_int($envelopeStatus) || ctype_digit($envelopeStatus))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($envelopeStatus, true), gettype($envelopeStatus)), __LINE__);
        }
        $this->EnvelopeStatus = $envelopeStatus;
        return $this;
    }
    /**
     * Get EnvelopeStatusDescription value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getEnvelopeStatusDescription()
    {
        return isset($this->EnvelopeStatusDescription) ? $this->EnvelopeStatusDescription : null;
    }
    /**
     * Set EnvelopeStatusDescription value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $envelopeStatusDescription
     * @return \StructType\InvoiceInquiryResponse
     */
    public function setEnvelopeStatusDescription($envelopeStatusDescription = null)
    {
        // validation for constraint: string
        if (!is_null($envelopeStatusDescription) && !is_string($envelopeStatusDescription)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($envelopeStatusDescription, true), gettype($envelopeStatusDescription)), __LINE__);
        }
        if (is_null($envelopeStatusDescription) || (is_array($envelopeStatusDescription) && empty($envelopeStatusDescription))) {
            unset($this->EnvelopeStatusDescription);
        } else {
            $this->EnvelopeStatusDescription = $envelopeStatusDescription;
        }
        return $this;
    }
    /**
     * Get HashValue value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getHashValue()
    {
        return isset($this->HashValue) ? $this->HashValue : null;
    }
    /**
     * Set HashValue value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $hashValue
     * @return \StructType\InvoiceInquiryResponse
     */
    public function setHashValue($hashValue = null)
    {
        // validation for constraint: string
        if (!is_null($hashValue) && !is_string($hashValue)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($hashValue, true), gettype($hashValue)), __LINE__);
        }
        if (is_null($hashValue) || (is_array($hashValue) && empty($hashValue))) {
            unset($this->HashValue);
        } else {
            $this->HashValue = $hashValue;
        }
        return $this;
    }
    /**
     * Get InvoiceNumber value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getInvoiceNumber()
    {
        return isset($this->InvoiceNumber) ? $this->InvoiceNumber : null;
    }
    /**
     * Set InvoiceNumber value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $invoiceNumber
     * @return \StructType\InvoiceInquiryResponse
     */
    public function setInvoiceNumber($invoiceNumber = null)
    {
        // validation for constraint: string
        if (!is_null($invoiceNumber) && !is_string($invoiceNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($invoiceNumber, true), gettype($invoiceNumber)), __LINE__);
        }
        if (is_null($invoiceNumber) || (is_array($invoiceNumber) && empty($invoiceNumber))) {
            unset($this->InvoiceNumber);
        } else {
            $this->InvoiceNumber = $invoiceNumber;
        }
        return $this;
    }
    /**
     * Get InvoiceStatus value
     * @return int|null
     */
    public function getInvoiceStatus()
    {
        return $this->InvoiceStatus;
    }
    /**
     * Set InvoiceStatus value
     * @param int $invoiceStatus
     * @return \StructType\InvoiceInquiryResponse
     */
    public function setInvoiceStatus($invoiceStatus = null)
    {
        // validation for constraint: int
        if (!is_null($invoiceStatus) && !(is_int($invoiceStatus) || ctype_digit($invoiceStatus))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($invoiceStatus, true), gettype($invoiceStatus)), __LINE__);
        }
        $this->InvoiceStatus = $invoiceStatus;
        return $this;
    }
    /**
     * Get InvoiceStatusDescription value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getInvoiceStatusDescription()
    {
        return isset($this->InvoiceStatusDescription) ? $this->InvoiceStatusDescription : null;
    }
    /**
     * Set InvoiceStatusDescription value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $invoiceStatusDescription
     * @return \StructType\InvoiceInquiryResponse
     */
    public function setInvoiceStatusDescription($invoiceStatusDescription = null)
    {
        // validation for constraint: string
        if (!is_null($invoiceStatusDescription) && !is_string($invoiceStatusDescription)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($invoiceStatusDescription, true), gettype($invoiceStatusDescription)), __LINE__);
        }
        if (is_null($invoiceStatusDescription) || (is_array($invoiceStatusDescription) && empty($invoiceStatusDescription))) {
            unset($this->InvoiceStatusDescription);
        } else {
            $this->InvoiceStatusDescription = $invoiceStatusDescription;
        }
        return $this;
    }
    /**
     * Get IsCancelled value
     * @return bool|null
     */
    public function getIsCancelled()
    {
        return $this->IsCancelled;
    }
    /**
     * Set IsCancelled value
     * @param bool $isCancelled
     * @return \StructType\InvoiceInquiryResponse
     */
    public function setIsCancelled($isCancelled = null)
    {
        // validation for constraint: boolean
        if (!is_null($isCancelled) && !is_bool($isCancelled)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($isCancelled, true), gettype($isCancelled)), __LINE__);
        }
        $this->IsCancelled = $isCancelled;
        return $this;
    }
    /**
     * Get IsCompleted value
     * @return bool|null
     */
    public function getIsCompleted()
    {
        return $this->IsCompleted;
    }
    /**
     * Set IsCompleted value
     * @param bool $isCompleted
     * @return \StructType\InvoiceInquiryResponse
     */
    public function setIsCompleted($isCompleted = null)
    {
        // validation for constraint: boolean
        if (!is_null($isCompleted) && !is_bool($isCompleted)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($isCompleted, true), gettype($isCompleted)), __LINE__);
        }
        $this->IsCompleted = $isCompleted;
        return $this;
    }
    /**
     * Get Notes value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getNotes()
    {
        return isset($this->Notes) ? $this->Notes : null;
    }
    /**
     * Set Notes value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $notes
     * @return \StructType\InvoiceInquiryResponse
     */
    public function setNotes($notes = null)
    {
        // validation for constraint: string
        if (!is_null($notes) && !is_string($notes)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($notes, true), gettype($notes)), __LINE__);
        }
        if (is_null($notes) || (is_array($notes) && empty($notes))) {
            unset($this->Notes);
        } else {
            $this->Notes = $notes;
        }
        return $this;
    }
    /**
     * Get SmsDescription value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getSmsDescription()
    {
        return isset($this->SmsDescription) ? $this->SmsDescription : null;
    }
    /**
     * Set SmsDescription value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $smsDescription
     * @return \StructType\InvoiceInquiryResponse
     */
    public function setSmsDescription($smsDescription = null)
    {
        // validation for constraint: string
        if (!is_null($smsDescription) && !is_string($smsDescription)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($smsDescription, true), gettype($smsDescription)), __LINE__);
        }
        if (is_null($smsDescription) || (is_array($smsDescription) && empty($smsDescription))) {
            unset($this->SmsDescription);
        } else {
            $this->SmsDescription = $smsDescription;
        }
        return $this;
    }
    /**
     * Get SmsStatus value
     * @return int|null
     */
    public function getSmsStatus()
    {
        return $this->SmsStatus;
    }
    /**
     * Set SmsStatus value
     * @param int $smsStatus
     * @return \StructType\InvoiceInquiryResponse
     */
    public function setSmsStatus($smsStatus = null)
    {
        // validation for constraint: int
        if (!is_null($smsStatus) && !(is_int($smsStatus) || ctype_digit($smsStatus))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($smsStatus, true), gettype($smsStatus)), __LINE__);
        }
        $this->SmsStatus = $smsStatus;
        return $this;
    }
    /**
     * Get SmsStatusDescription value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getSmsStatusDescription()
    {
        return isset($this->SmsStatusDescription) ? $this->SmsStatusDescription : null;
    }
    /**
     * Set SmsStatusDescription value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $smsStatusDescription
     * @return \StructType\InvoiceInquiryResponse
     */
    public function setSmsStatusDescription($smsStatusDescription = null)
    {
        // validation for constraint: string
        if (!is_null($smsStatusDescription) && !is_string($smsStatusDescription)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($smsStatusDescription, true), gettype($smsStatusDescription)), __LINE__);
        }
        if (is_null($smsStatusDescription) || (is_array($smsStatusDescription) && empty($smsStatusDescription))) {
            unset($this->SmsStatusDescription);
        } else {
            $this->SmsStatusDescription = $smsStatusDescription;
        }
        return $this;
    }
    /**
     * Get UUID value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getUUID()
    {
        return isset($this->UUID) ? $this->UUID : null;
    }
    /**
     * Set UUID value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $uUID
     * @return \StructType\InvoiceInquiryResponse
     */
    public function setUUID($uUID = null)
    {
        // validation for constraint: string
        if (!is_null($uUID) && !is_string($uUID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($uUID, true), gettype($uUID)), __LINE__);
        }
        if (is_null($uUID) || (is_array($uUID) && empty($uUID))) {
            unset($this->UUID);
        } else {
            $this->UUID = $uUID;
        }
        return $this;
    }
    /**
     * Get InvoiceInquiryResult value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\InvoiceInquiryResponse|null
     */
    public function getInvoiceInquiryResult()
    {
        return isset($this->InvoiceInquiryResult) ? $this->InvoiceInquiryResult : null;
    }
    /**
     * Set InvoiceInquiryResult value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\InvoiceInquiryResponse $invoiceInquiryResult
     * @return \StructType\InvoiceInquiryResponse
     */
    public function setInvoiceInquiryResult(\StructType\InvoiceInquiryResponse $invoiceInquiryResult = null)
    {
        if (is_null($invoiceInquiryResult) || (is_array($invoiceInquiryResult) && empty($invoiceInquiryResult))) {
            unset($this->InvoiceInquiryResult);
        } else {
            $this->InvoiceInquiryResult = $invoiceInquiryResult;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\InvoiceInquiryResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
