<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for MonetaryTotal StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:MonetaryTotal
 * @subpackage Structs
 */
class MonetaryTotal extends AbstractStructBase
{
    /**
     * The AllowanceTotalAmount
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Amount
     */
    public $AllowanceTotalAmount;
    /**
     * The ChargeTotalAmount
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Amount
     */
    public $ChargeTotalAmount;
    /**
     * The LineExtensionAmount
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Amount
     */
    public $LineExtensionAmount;
    /**
     * The PayableAmount
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Amount
     */
    public $PayableAmount;
    /**
     * The PayableRoundingAmount
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Amount
     */
    public $PayableRoundingAmount;
    /**
     * The TaxExclusiveAmount
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Amount
     */
    public $TaxExclusiveAmount;
    /**
     * The TaxInclusiveAmount
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Amount
     */
    public $TaxInclusiveAmount;
    /**
     * Constructor method for MonetaryTotal
     * @uses MonetaryTotal::setAllowanceTotalAmount()
     * @uses MonetaryTotal::setChargeTotalAmount()
     * @uses MonetaryTotal::setLineExtensionAmount()
     * @uses MonetaryTotal::setPayableAmount()
     * @uses MonetaryTotal::setPayableRoundingAmount()
     * @uses MonetaryTotal::setTaxExclusiveAmount()
     * @uses MonetaryTotal::setTaxInclusiveAmount()
     * @param \StructType\Amount $allowanceTotalAmount
     * @param \StructType\Amount $chargeTotalAmount
     * @param \StructType\Amount $lineExtensionAmount
     * @param \StructType\Amount $payableAmount
     * @param \StructType\Amount $payableRoundingAmount
     * @param \StructType\Amount $taxExclusiveAmount
     * @param \StructType\Amount $taxInclusiveAmount
     */
    public function __construct(\StructType\Amount $allowanceTotalAmount = null, \StructType\Amount $chargeTotalAmount = null, \StructType\Amount $lineExtensionAmount = null, \StructType\Amount $payableAmount = null, \StructType\Amount $payableRoundingAmount = null, \StructType\Amount $taxExclusiveAmount = null, \StructType\Amount $taxInclusiveAmount = null)
    {
        $this
            ->setAllowanceTotalAmount($allowanceTotalAmount)
            ->setChargeTotalAmount($chargeTotalAmount)
            ->setLineExtensionAmount($lineExtensionAmount)
            ->setPayableAmount($payableAmount)
            ->setPayableRoundingAmount($payableRoundingAmount)
            ->setTaxExclusiveAmount($taxExclusiveAmount)
            ->setTaxInclusiveAmount($taxInclusiveAmount);
    }
    /**
     * Get AllowanceTotalAmount value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Amount|null
     */
    public function getAllowanceTotalAmount()
    {
        return isset($this->AllowanceTotalAmount) ? $this->AllowanceTotalAmount : null;
    }
    /**
     * Set AllowanceTotalAmount value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\Amount $allowanceTotalAmount
     * @return \StructType\MonetaryTotal
     */
    public function setAllowanceTotalAmount(\StructType\Amount $allowanceTotalAmount = null)
    {
        if (is_null($allowanceTotalAmount) || (is_array($allowanceTotalAmount) && empty($allowanceTotalAmount))) {
            unset($this->AllowanceTotalAmount);
        } else {
            $this->AllowanceTotalAmount = $allowanceTotalAmount;
        }
        return $this;
    }
    /**
     * Get ChargeTotalAmount value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Amount|null
     */
    public function getChargeTotalAmount()
    {
        return isset($this->ChargeTotalAmount) ? $this->ChargeTotalAmount : null;
    }
    /**
     * Set ChargeTotalAmount value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\Amount $chargeTotalAmount
     * @return \StructType\MonetaryTotal
     */
    public function setChargeTotalAmount(\StructType\Amount $chargeTotalAmount = null)
    {
        if (is_null($chargeTotalAmount) || (is_array($chargeTotalAmount) && empty($chargeTotalAmount))) {
            unset($this->ChargeTotalAmount);
        } else {
            $this->ChargeTotalAmount = $chargeTotalAmount;
        }
        return $this;
    }
    /**
     * Get LineExtensionAmount value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Amount|null
     */
    public function getLineExtensionAmount()
    {
        return isset($this->LineExtensionAmount) ? $this->LineExtensionAmount : null;
    }
    /**
     * Set LineExtensionAmount value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\Amount $lineExtensionAmount
     * @return \StructType\MonetaryTotal
     */
    public function setLineExtensionAmount(\StructType\Amount $lineExtensionAmount = null)
    {
        if (is_null($lineExtensionAmount) || (is_array($lineExtensionAmount) && empty($lineExtensionAmount))) {
            unset($this->LineExtensionAmount);
        } else {
            $this->LineExtensionAmount = $lineExtensionAmount;
        }
        return $this;
    }
    /**
     * Get PayableAmount value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Amount|null
     */
    public function getPayableAmount()
    {
        return isset($this->PayableAmount) ? $this->PayableAmount : null;
    }
    /**
     * Set PayableAmount value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\Amount $payableAmount
     * @return \StructType\MonetaryTotal
     */
    public function setPayableAmount(\StructType\Amount $payableAmount = null)
    {
        if (is_null($payableAmount) || (is_array($payableAmount) && empty($payableAmount))) {
            unset($this->PayableAmount);
        } else {
            $this->PayableAmount = $payableAmount;
        }
        return $this;
    }
    /**
     * Get PayableRoundingAmount value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Amount|null
     */
    public function getPayableRoundingAmount()
    {
        return isset($this->PayableRoundingAmount) ? $this->PayableRoundingAmount : null;
    }
    /**
     * Set PayableRoundingAmount value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\Amount $payableRoundingAmount
     * @return \StructType\MonetaryTotal
     */
    public function setPayableRoundingAmount(\StructType\Amount $payableRoundingAmount = null)
    {
        if (is_null($payableRoundingAmount) || (is_array($payableRoundingAmount) && empty($payableRoundingAmount))) {
            unset($this->PayableRoundingAmount);
        } else {
            $this->PayableRoundingAmount = $payableRoundingAmount;
        }
        return $this;
    }
    /**
     * Get TaxExclusiveAmount value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Amount|null
     */
    public function getTaxExclusiveAmount()
    {
        return isset($this->TaxExclusiveAmount) ? $this->TaxExclusiveAmount : null;
    }
    /**
     * Set TaxExclusiveAmount value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\Amount $taxExclusiveAmount
     * @return \StructType\MonetaryTotal
     */
    public function setTaxExclusiveAmount(\StructType\Amount $taxExclusiveAmount = null)
    {
        if (is_null($taxExclusiveAmount) || (is_array($taxExclusiveAmount) && empty($taxExclusiveAmount))) {
            unset($this->TaxExclusiveAmount);
        } else {
            $this->TaxExclusiveAmount = $taxExclusiveAmount;
        }
        return $this;
    }
    /**
     * Get TaxInclusiveAmount value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Amount|null
     */
    public function getTaxInclusiveAmount()
    {
        return isset($this->TaxInclusiveAmount) ? $this->TaxInclusiveAmount : null;
    }
    /**
     * Set TaxInclusiveAmount value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\Amount $taxInclusiveAmount
     * @return \StructType\MonetaryTotal
     */
    public function setTaxInclusiveAmount(\StructType\Amount $taxInclusiveAmount = null)
    {
        if (is_null($taxInclusiveAmount) || (is_array($taxInclusiveAmount) && empty($taxInclusiveAmount))) {
            unset($this->TaxInclusiveAmount);
        } else {
            $this->TaxInclusiveAmount = $taxInclusiveAmount;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\MonetaryTotal
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
