<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for OutgoingInvoice StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:OutgoingInvoice
 * @subpackage Structs
 */
class OutgoingInvoice extends AbstractStructBase
{
    /**
     * The Body
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\InvoiceBody
     */
    public $Body;
    /**
     * The Header
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\OutgoingInvoiceHeader
     */
    public $Header;
    /**
     * Constructor method for OutgoingInvoice
     * @uses OutgoingInvoice::setBody()
     * @uses OutgoingInvoice::setHeader()
     * @param \StructType\InvoiceBody $body
     * @param \StructType\OutgoingInvoiceHeader $header
     */
    public function __construct(\StructType\InvoiceBody $body = null, \StructType\OutgoingInvoiceHeader $header = null)
    {
        $this
            ->setBody($body)
            ->setHeader($header);
    }
    /**
     * Get Body value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\InvoiceBody|null
     */
    public function getBody()
    {
        return isset($this->Body) ? $this->Body : null;
    }
    /**
     * Set Body value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\InvoiceBody $body
     * @return \StructType\OutgoingInvoice
     */
    public function setBody(\StructType\InvoiceBody $body = null)
    {
        if (is_null($body) || (is_array($body) && empty($body))) {
            unset($this->Body);
        } else {
            $this->Body = $body;
        }
        return $this;
    }
    /**
     * Get Header value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\OutgoingInvoiceHeader|null
     */
    public function getHeader()
    {
        return isset($this->Header) ? $this->Header : null;
    }
    /**
     * Set Header value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\OutgoingInvoiceHeader $header
     * @return \StructType\OutgoingInvoice
     */
    public function setHeader(\StructType\OutgoingInvoiceHeader $header = null)
    {
        if (is_null($header) || (is_array($header) && empty($header))) {
            unset($this->Header);
        } else {
            $this->Header = $header;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\OutgoingInvoice
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
