<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for RepeatEArchiveSMSRequest StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:RepeatEArchiveSMSRequest
 * @subpackage Structs
 */
class RepeatEArchiveSMSRequest extends RequestBase
{
    /**
     * The GsmNumber
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $GsmNumber;
    /**
     * The ReferenceNumber
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $ReferenceNumber;
    /**
     * The SmsBody
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $SmsBody;
    /**
     * The TrackNumber
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $TrackNumber;
    /**
     * Constructor method for RepeatEArchiveSMSRequest
     * @uses RepeatEArchiveSMSRequest::setGsmNumber()
     * @uses RepeatEArchiveSMSRequest::setReferenceNumber()
     * @uses RepeatEArchiveSMSRequest::setSmsBody()
     * @uses RepeatEArchiveSMSRequest::setTrackNumber()
     * @param string $gsmNumber
     * @param int $referenceNumber
     * @param string $smsBody
     * @param string $trackNumber
     */
    public function __construct($gsmNumber = null, $referenceNumber = null, $smsBody = null, $trackNumber = null)
    {
        $this
            ->setGsmNumber($gsmNumber)
            ->setReferenceNumber($referenceNumber)
            ->setSmsBody($smsBody)
            ->setTrackNumber($trackNumber);
    }
    /**
     * Get GsmNumber value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getGsmNumber()
    {
        return isset($this->GsmNumber) ? $this->GsmNumber : null;
    }
    /**
     * Set GsmNumber value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $gsmNumber
     * @return \StructType\RepeatEArchiveSMSRequest
     */
    public function setGsmNumber($gsmNumber = null)
    {
        // validation for constraint: string
        if (!is_null($gsmNumber) && !is_string($gsmNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($gsmNumber, true), gettype($gsmNumber)), __LINE__);
        }
        if (is_null($gsmNumber) || (is_array($gsmNumber) && empty($gsmNumber))) {
            unset($this->GsmNumber);
        } else {
            $this->GsmNumber = $gsmNumber;
        }
        return $this;
    }
    /**
     * Get ReferenceNumber value
     * @return int|null
     */
    public function getReferenceNumber()
    {
        return $this->ReferenceNumber;
    }
    /**
     * Set ReferenceNumber value
     * @param int $referenceNumber
     * @return \StructType\RepeatEArchiveSMSRequest
     */
    public function setReferenceNumber($referenceNumber = null)
    {
        // validation for constraint: int
        if (!is_null($referenceNumber) && !(is_int($referenceNumber) || ctype_digit($referenceNumber))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($referenceNumber, true), gettype($referenceNumber)), __LINE__);
        }
        $this->ReferenceNumber = $referenceNumber;
        return $this;
    }
    /**
     * Get SmsBody value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getSmsBody()
    {
        return isset($this->SmsBody) ? $this->SmsBody : null;
    }
    /**
     * Set SmsBody value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $smsBody
     * @return \StructType\RepeatEArchiveSMSRequest
     */
    public function setSmsBody($smsBody = null)
    {
        // validation for constraint: string
        if (!is_null($smsBody) && !is_string($smsBody)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($smsBody, true), gettype($smsBody)), __LINE__);
        }
        if (is_null($smsBody) || (is_array($smsBody) && empty($smsBody))) {
            unset($this->SmsBody);
        } else {
            $this->SmsBody = $smsBody;
        }
        return $this;
    }
    /**
     * Get TrackNumber value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getTrackNumber()
    {
        return isset($this->TrackNumber) ? $this->TrackNumber : null;
    }
    /**
     * Set TrackNumber value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $trackNumber
     * @return \StructType\RepeatEArchiveSMSRequest
     */
    public function setTrackNumber($trackNumber = null)
    {
        // validation for constraint: string
        if (!is_null($trackNumber) && !is_string($trackNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($trackNumber, true), gettype($trackNumber)), __LINE__);
        }
        if (is_null($trackNumber) || (is_array($trackNumber) && empty($trackNumber))) {
            unset($this->TrackNumber);
        } else {
            $this->TrackNumber = $trackNumber;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\RepeatEArchiveSMSRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
