<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SendInvoicesRawResponse StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:SendInvoicesRawResponse
 * @subpackage Structs
 */
class SendInvoicesRawResponse extends ResponseBase
{
    /**
     * The Items
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfInvoiceResultItem
     */
    public $Items;
    /**
     * The SendInvoicesRawResult
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\SendInvoicesRawResponse
     */
    public $SendInvoicesRawResult;
    /**
     * Constructor method for SendInvoicesRawResponse
     * @uses SendInvoicesRawResponse::setItems()
     * @uses SendInvoicesRawResponse::setSendInvoicesRawResult()
     * @param \ArrayType\ArrayOfInvoiceResultItem $items
     * @param \StructType\SendInvoicesRawResponse $sendInvoicesRawResult
     */
    public function __construct(\ArrayType\ArrayOfInvoiceResultItem $items = null, \StructType\SendInvoicesRawResponse $sendInvoicesRawResult = null)
    {
        $this
            ->setItems($items)
            ->setSendInvoicesRawResult($sendInvoicesRawResult);
    }
    /**
     * Get Items value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfInvoiceResultItem|null
     */
    public function getItems()
    {
        return isset($this->Items) ? $this->Items : null;
    }
    /**
     * Set Items value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfInvoiceResultItem $items
     * @return \StructType\SendInvoicesRawResponse
     */
    public function setItems(\ArrayType\ArrayOfInvoiceResultItem $items = null)
    {
        if (is_null($items) || (is_array($items) && empty($items))) {
            unset($this->Items);
        } else {
            $this->Items = $items;
        }
        return $this;
    }
    /**
     * Get SendInvoicesRawResult value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\SendInvoicesRawResponse|null
     */
    public function getSendInvoicesRawResult()
    {
        return isset($this->SendInvoicesRawResult) ? $this->SendInvoicesRawResult : null;
    }
    /**
     * Set SendInvoicesRawResult value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\SendInvoicesRawResponse $sendInvoicesRawResult
     * @return \StructType\SendInvoicesRawResponse
     */
    public function setSendInvoicesRawResult(\StructType\SendInvoicesRawResponse $sendInvoicesRawResult = null)
    {
        if (is_null($sendInvoicesRawResult) || (is_array($sendInvoicesRawResult) && empty($sendInvoicesRawResult))) {
            unset($this->SendInvoicesRawResult);
        } else {
            $this->SendInvoicesRawResult = $sendInvoicesRawResult;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\SendInvoicesRawResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
