<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SendInvoicesResponse StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:SendInvoicesResponse
 * @subpackage Structs
 */
class SendInvoicesResponse extends ResponseBase
{
    /**
     * The Items
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfInvoiceResultItem
     */
    public $Items;
    /**
     * The SendInvoicesResult
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\SendInvoicesResponse
     */
    public $SendInvoicesResult;
    /**
     * Constructor method for SendInvoicesResponse
     * @uses SendInvoicesResponse::setItems()
     * @uses SendInvoicesResponse::setSendInvoicesResult()
     * @param \ArrayType\ArrayOfInvoiceResultItem $items
     * @param \StructType\SendInvoicesResponse $sendInvoicesResult
     */
    public function __construct(\ArrayType\ArrayOfInvoiceResultItem $items = null, \StructType\SendInvoicesResponse $sendInvoicesResult = null)
    {
        $this
            ->setItems($items)
            ->setSendInvoicesResult($sendInvoicesResult);
    }
    /**
     * Get Items value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfInvoiceResultItem|null
     */
    public function getItems()
    {
        return isset($this->Items) ? $this->Items : null;
    }
    /**
     * Set Items value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfInvoiceResultItem $items
     * @return \StructType\SendInvoicesResponse
     */
    public function setItems(\ArrayType\ArrayOfInvoiceResultItem $items = null)
    {
        if (is_null($items) || (is_array($items) && empty($items))) {
            unset($this->Items);
        } else {
            $this->Items = $items;
        }
        return $this;
    }
    /**
     * Get SendInvoicesResult value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\SendInvoicesResponse|null
     */
    public function getSendInvoicesResult()
    {
        return isset($this->SendInvoicesResult) ? $this->SendInvoicesResult : null;
    }
    /**
     * Set SendInvoicesResult value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\SendInvoicesResponse $sendInvoicesResult
     * @return \StructType\SendInvoicesResponse
     */
    public function setSendInvoicesResult(\StructType\SendInvoicesResponse $sendInvoicesResult = null)
    {
        if (is_null($sendInvoicesResult) || (is_array($sendInvoicesResult) && empty($sendInvoicesResult))) {
            unset($this->SendInvoicesResult);
        } else {
            $this->SendInvoicesResult = $sendInvoicesResult;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\SendInvoicesResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
