<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ShipmentStage StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ShipmentStage
 * @subpackage Structs
 */
class ShipmentStage extends AbstractStructBase
{
    /**
     * The DriverPerson
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfPerson
     */
    public $DriverPerson;
    /**
     * The ID
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ID;
    /**
     * The TransportMeans
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TransportMeans
     */
    public $TransportMeans;
    /**
     * The TransportModeCode
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $TransportModeCode;
    /**
     * Constructor method for ShipmentStage
     * @uses ShipmentStage::setDriverPerson()
     * @uses ShipmentStage::setID()
     * @uses ShipmentStage::setTransportMeans()
     * @uses ShipmentStage::setTransportModeCode()
     * @param \ArrayType\ArrayOfPerson $driverPerson
     * @param string $iD
     * @param \StructType\TransportMeans $transportMeans
     * @param string $transportModeCode
     */
    public function __construct(\ArrayType\ArrayOfPerson $driverPerson = null, $iD = null, \StructType\TransportMeans $transportMeans = null, $transportModeCode = null)
    {
        $this
            ->setDriverPerson($driverPerson)
            ->setID($iD)
            ->setTransportMeans($transportMeans)
            ->setTransportModeCode($transportModeCode);
    }
    /**
     * Get DriverPerson value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfPerson|null
     */
    public function getDriverPerson()
    {
        return isset($this->DriverPerson) ? $this->DriverPerson : null;
    }
    /**
     * Set DriverPerson value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfPerson $driverPerson
     * @return \StructType\ShipmentStage
     */
    public function setDriverPerson(\ArrayType\ArrayOfPerson $driverPerson = null)
    {
        if (is_null($driverPerson) || (is_array($driverPerson) && empty($driverPerson))) {
            unset($this->DriverPerson);
        } else {
            $this->DriverPerson = $driverPerson;
        }
        return $this;
    }
    /**
     * Get ID value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getID()
    {
        return isset($this->ID) ? $this->ID : null;
    }
    /**
     * Set ID value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $iD
     * @return \StructType\ShipmentStage
     */
    public function setID($iD = null)
    {
        // validation for constraint: string
        if (!is_null($iD) && !is_string($iD)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($iD, true), gettype($iD)), __LINE__);
        }
        if (is_null($iD) || (is_array($iD) && empty($iD))) {
            unset($this->ID);
        } else {
            $this->ID = $iD;
        }
        return $this;
    }
    /**
     * Get TransportMeans value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TransportMeans|null
     */
    public function getTransportMeans()
    {
        return isset($this->TransportMeans) ? $this->TransportMeans : null;
    }
    /**
     * Set TransportMeans value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\TransportMeans $transportMeans
     * @return \StructType\ShipmentStage
     */
    public function setTransportMeans(\StructType\TransportMeans $transportMeans = null)
    {
        if (is_null($transportMeans) || (is_array($transportMeans) && empty($transportMeans))) {
            unset($this->TransportMeans);
        } else {
            $this->TransportMeans = $transportMeans;
        }
        return $this;
    }
    /**
     * Get TransportModeCode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getTransportModeCode()
    {
        return isset($this->TransportModeCode) ? $this->TransportModeCode : null;
    }
    /**
     * Set TransportModeCode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $transportModeCode
     * @return \StructType\ShipmentStage
     */
    public function setTransportModeCode($transportModeCode = null)
    {
        // validation for constraint: string
        if (!is_null($transportModeCode) && !is_string($transportModeCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($transportModeCode, true), gettype($transportModeCode)), __LINE__);
        }
        if (is_null($transportModeCode) || (is_array($transportModeCode) && empty($transportModeCode))) {
            unset($this->TransportModeCode);
        } else {
            $this->TransportModeCode = $transportModeCode;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ShipmentStage
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
