<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SupplierParty StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:SupplierParty
 * @subpackage Structs
 */
class SupplierParty extends AbstractStructBase
{
    /**
     * The DespatchContact
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Contact
     */
    public $DespatchContact;
    /**
     * The Party
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Party
     */
    public $Party;
    /**
     * Constructor method for SupplierParty
     * @uses SupplierParty::setDespatchContact()
     * @uses SupplierParty::setParty()
     * @param \StructType\Contact $despatchContact
     * @param \StructType\Party $party
     */
    public function __construct(\StructType\Contact $despatchContact = null, \StructType\Party $party = null)
    {
        $this
            ->setDespatchContact($despatchContact)
            ->setParty($party);
    }
    /**
     * Get DespatchContact value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Contact|null
     */
    public function getDespatchContact()
    {
        return isset($this->DespatchContact) ? $this->DespatchContact : null;
    }
    /**
     * Set DespatchContact value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\Contact $despatchContact
     * @return \StructType\SupplierParty
     */
    public function setDespatchContact(\StructType\Contact $despatchContact = null)
    {
        if (is_null($despatchContact) || (is_array($despatchContact) && empty($despatchContact))) {
            unset($this->DespatchContact);
        } else {
            $this->DespatchContact = $despatchContact;
        }
        return $this;
    }
    /**
     * Get Party value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Party|null
     */
    public function getParty()
    {
        return isset($this->Party) ? $this->Party : null;
    }
    /**
     * Set Party value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\Party $party
     * @return \StructType\SupplierParty
     */
    public function setParty(\StructType\Party $party = null)
    {
        if (is_null($party) || (is_array($party) && empty($party))) {
            unset($this->Party);
        } else {
            $this->Party = $party;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\SupplierParty
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
